#!/bin/sh

. /etc/PG.conf
APPCONF=${PGETC}/App/snmpwalk.conf

if [ ! -f ${APPCONF} ]; then
    echo "CONF NOT FOUND!"
    exit 1
fi

. ${APPCONF}
arpoid=".1.3.6.1.2.1.4.22.1.2"

SNMPWALK=/sbin/snmpwalk
FLOWEYE=/usr/ramdisk/bin/floweye
MSGFILE=/usr/ramdisk/tmp/snmpmac.txt
LOGFILE=/usr/ramdisk/tmp/getipmac.log

lastworktime=$((`date +%s` - 1800))

[ ! -d /usr/ramdisk/tmp ] && mkdir /usr/ramdisk/tmp

while true
do
    dot=""
    cursecs=`date +%s`
    elapse=$((${cursecs} - ${lastworktime}))

    if [ ${elapse} -ge ${sleeptime} ]; then 
        lastworktime="${cursecs}"
        
        echo "[" > ${LOGFILE}
        
        for ip in ${devip}; do
            cur=`date +"%Y-%m-%d %H:%M:%S"`
            
            if [ "${ip}" = "0.0.0.0" ]; then
                echo "${dot}{\"ret\":\"NOT_RUN\", \"time\": \"${cur}\", \"msg\": \"\"}" >> ${LOGFILE}
                [ "${dot}" = "" ] && dot=","
                continue
            fi
            
            msg=`${SNMPWALK} -v $version -Cc -c $commuty $ip $arpoid 2>&1`
            
            if [ $? -eq 0 ]; then
                data=`echo "${msg}" | \
                awk '{ \
                    if($3=="STRING:"){ \
                        split($1,arr,"."); \
                        print arr[3]"\."arr[4]"\."arr[5]"\."arr[6]" "\
                        $4 \
                    } \
                    else if($3=="Hex-STRING:"){ \
                        split($1, arr, "."); \
                        print arr[12]"\."arr[13]"\."arr[14]"\."arr[15]" "\
                        $4":"$5":"$6":"$7":"$8":"$9 \
                    } \
                }'`

                echo "$data" > ${MSGFILE}
                ${FLOWEYE} ipmac load file=${MSGFILE}

                num=`cat ${MSGFILE} | wc -l | awk '{print $1}'`
                echo "${dot}{\"ret\":0, \"time\": \"${cur}\", \"msg\": \"ȡ${num}\"}" >> ${LOGFILE}         
                rm ${MSGFILE}

            else
                echo "${dot}{\"ret\":1, \"time\": \"${cur}\", \"msg\": \"${msg}\"}" >> ${LOGFILE}
            fi
            
            [ "${dot}" = "" ] && dot=","

        done
        
        echo "]" >>${LOGFILE}
    fi
    
    sleep 1

done
